.........1.........2.........3.........4....^....5.........6.........7.........8

;Mode Change by Toni Baker from ZX Computing May 1987

;The RANDOMIZE USR 32814 function to switch to 128 mode doesn't work.  ]
;I've tried entering 48k mode from the menu, from the SPECTRUM command,]
;and from RANDOMIZE USR 32781 (which works); but whichever way I get to]
;48k mode, trying to enter 128k mode with RANDOMIZE USR 32814 always   ]
;crashes. The call address 32814(802Eh) is correct and the code matches]
;the listing, so there must be an error in the listing.            JimG]

                          ORG  8000h
8000 F5       SWAP_2      PUSH AF
8001 C5                   PUSH BC           ;Stack A,B,C and flags
8002 01FD7F               LD   BC,#7FFD     ;BC=port number for paging
8005 3A5C5B               LD   A,(BANK_M)   ;A=current pages, etc.
8008 E61F                 AND  #1F          ;Reset bit 5, to signal "unlocked"
800A C3085B               JP   #5B08,SWAP+8 ;Jump to complete SWAP routine

                          ORG  800Dh
800D ED7B3D5C MODE_48     LD   SP,(ERR_SP)  ;Empty machine stack down to
                                            ;error return address
8011 E1                   POP  HL           ;Drop error return address
8012 210313               LD   HL,#1303,MAIN_4
8015 E5                   PUSH HL           ;Stack 48k mode error return addr
8016 21761B               LD   HL,#1B76,STMT_RET
8019 E5                   PUSH HL           ;Stack return address from
                                            ;statement execution
801A 2A455C               LD   HL,(PPC)     ;HL=current line number
801D 22425C               LD   (NEWPPC),HL  ;Store as next line number
8020 3A475C               LD   A,(SUBPPC)   ;A=current statement number
8023 3C                   INC  A
8024 32445C               LD   (NSPPC),A    ;Store statement number of next
                                            ;statement to interpret
8027 0600                 LD   B,#00        ;Bit 4 reset signals "48k mode"
8029 11BE15               LD   DE,#15BE     ;DE points to chan "P" info (48k)
802C 1810                 JR   MODE_CHANGE

                          ORG  802Eh
802E 3EC3     MODE_128    LD   A,#C3
8030 32005B               LD   (SWAP),A     ;Store a JP instruction at SWAP
8033 210080               LD   HL,SWAP_2
8036 22015B               LD   (SWAP+1),HL  ;Set JP destination as SWAP_2
8039 0610                 LD   B,#10        ;Bit 4 set signals "128k mode"
803B 115480               LD   DE,#8054     ;DE points to chan "P" info (128k)
803E 3A3B5C   MODE_CHANGE LD   A,(FLAGS)
8041 E6EF                 AND  #EF          ;Reset bit 4
8043 B0                   OR   B            ;Assign bit 4 according to mode
8044 323B5C               LD   (FLAGS),A    ;Store revised flags
8047 2A4F5C               LD   HL,(CHANS)   ;HL points to base of channel
                                            ;information area
804A 010F00               LD   BC,#000F
804D 09                   ADD  HL,BC        ;HL points to info for channel "P"
804E EB                   EX   DE,HL        ;DE points to info for channel "P"
804F 0E04                 LD   C,#04        ;BC=number of bytes to copy (=4)
8051 EDB0                 LDIR              ;Copy data into channel "P" info
8053 C9                   RET

                          ORG  8054h
8054 345B     P_128       DEFW 5B34,POUT    ;Channel "P" output address
8056 2F5B                 DEFW 5B2F,PIN     ;Channel "P" input address


